---
title: Trigger a Bits AI investigation
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Bits AI
---

# Trigger a Bits AI investigation{% #trigger-a-bits-ai-investigation %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                     |
| ----------------- | ---------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/bits-ai/investigations |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/bits-ai/investigations |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/bits-ai/investigations      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/bits-ai/investigations      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/bits-ai/investigations  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/bits-ai/investigations     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/bits-ai/investigations |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/bits-ai/investigations |

### Overview

Trigger a new Bits AI investigation based on a monitor alert. This endpoint requires the `bits_investigations_write` permission.

OAuth apps require the `bits_investigations_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#bits-ai) to access this endpoint.



### Request

#### Body Data (required)

Trigger investigation request body.

{% tab title="Model" %}

| Parent field          | Field                                   | Type   | Description                                                                                                |
| --------------------- | --------------------------------------- | ------ | ---------------------------------------------------------------------------------------------------------- |
|                       | data [*required*]                  | object | Data for the trigger investigation request.                                                                |
| data                  | attributes [*required*]            | object | Attributes for the trigger investigation request.                                                          |
| attributes            | trigger [*required*]               | object | The trigger definition for starting an investigation.                                                      |
| trigger               | monitor_alert_trigger [*required*] | object | Attributes for a monitor alert trigger.                                                                    |
| monitor_alert_trigger | event_id [*required*]              | string | The event ID associated with the monitor alert.                                                            |
| monitor_alert_trigger | event_ts [*required*]              | int64  | The timestamp of the event in Unix milliseconds.                                                           |
| monitor_alert_trigger | monitor_id [*required*]            | int64  | The monitor ID that triggered the alert.                                                                   |
| trigger               | type [*required*]                  | enum   | The type of trigger for the investigation. Allowed enum values: `monitor_alert_trigger`                    |
| data                  | type [*required*]                  | enum   | The resource type for trigger investigation requests. Allowed enum values: `trigger_investigation_request` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "trigger": {
        "monitor_alert_trigger": {
          "event_id": "1234567890123456789",
          "event_ts": 1700000000000,
          "monitor_id": 12345678
        },
        "type": "monitor_alert_trigger"
      }
    },
    "type": "trigger_investigation_request"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response after triggering an investigation.

| Parent field | Field                              | Type   | Description                                                                                                  |
| ------------ | ---------------------------------- | ------ | ------------------------------------------------------------------------------------------------------------ |
|              | data [*required*]             | object | Data for the trigger investigation response.                                                                 |
| data         | attributes [*required*]       | object | Attributes for the trigger investigation response.                                                           |
| attributes   | investigation_id [*required*] | string | The ID of the investigation that was created.                                                                |
| data         | id [*required*]               | string | Unique identifier for the trigger response.                                                                  |
| data         | type [*required*]             | enum   | The resource type for trigger investigation responses. Allowed enum values: `trigger_investigation_response` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "investigation_id": "a1b2c3d4-5e6f-7a8b-9c0d-1e2f3a4b5c6d"
    },
    "id": "f5e6a7b8-c9d0-1e2f-3a4b-5c6d7e8f9a0b",
    "type": "trigger_investigation_response"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/bits-ai/investigations" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "trigger": {
        "monitor_alert_trigger": {
          "event_id": "1234567890123456789",
          "event_ts": 1700000000000,
          "monitor_id": 12345678
        },
        "type": "monitor_alert_trigger"
      }
    },
    "type": "trigger_investigation_request"
  }
}
EOF 
                
##### 

```python
"""
Trigger a Bits AI investigation returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.bits_ai_api import BitsAIApi
from datadog_api_client.v2.model.monitor_alert_trigger_attributes import MonitorAlertTriggerAttributes
from datadog_api_client.v2.model.trigger_attributes import TriggerAttributes
from datadog_api_client.v2.model.trigger_investigation_request import TriggerInvestigationRequest
from datadog_api_client.v2.model.trigger_investigation_request_data import TriggerInvestigationRequestData
from datadog_api_client.v2.model.trigger_investigation_request_data_attributes import (
    TriggerInvestigationRequestDataAttributes,
)
from datadog_api_client.v2.model.trigger_investigation_request_type import TriggerInvestigationRequestType
from datadog_api_client.v2.model.trigger_type import TriggerType

body = TriggerInvestigationRequest(
    data=TriggerInvestigationRequestData(
        attributes=TriggerInvestigationRequestDataAttributes(
            trigger=TriggerAttributes(
                monitor_alert_trigger=MonitorAlertTriggerAttributes(
                    event_id="1234567890123456789",
                    event_ts=1700000000000,
                    monitor_id=12345678,
                ),
                type=TriggerType.MONITOR_ALERT_TRIGGER,
            ),
        ),
        type=TriggerInvestigationRequestType.TRIGGER_INVESTIGATION_REQUEST,
    ),
)

configuration = Configuration()
configuration.unstable_operations["trigger_investigation"] = True
with ApiClient(configuration) as api_client:
    api_instance = BitsAIApi(api_client)
    response = api_instance.trigger_investigation(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Trigger a Bits AI investigation returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.trigger_investigation".to_sym] = true
end
api_instance = DatadogAPIClient::V2::BitsAIAPI.new

body = DatadogAPIClient::V2::TriggerInvestigationRequest.new({
  data: DatadogAPIClient::V2::TriggerInvestigationRequestData.new({
    attributes: DatadogAPIClient::V2::TriggerInvestigationRequestDataAttributes.new({
      trigger: DatadogAPIClient::V2::TriggerAttributes.new({
        monitor_alert_trigger: DatadogAPIClient::V2::MonitorAlertTriggerAttributes.new({
          event_id: "1234567890123456789",
          event_ts: 1700000000000,
          monitor_id: 12345678,
        }),
        type: DatadogAPIClient::V2::TriggerType::MONITOR_ALERT_TRIGGER,
      }),
    }),
    type: DatadogAPIClient::V2::TriggerInvestigationRequestType::TRIGGER_INVESTIGATION_REQUEST,
  }),
})
p api_instance.trigger_investigation(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Trigger a Bits AI investigation returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.TriggerInvestigationRequest{
		Data: datadogV2.TriggerInvestigationRequestData{
			Attributes: datadogV2.TriggerInvestigationRequestDataAttributes{
				Trigger: datadogV2.TriggerAttributes{
					MonitorAlertTrigger: datadogV2.MonitorAlertTriggerAttributes{
						EventId:   "1234567890123456789",
						EventTs:   1700000000000,
						MonitorId: 12345678,
					},
					Type: datadogV2.TRIGGERTYPE_MONITOR_ALERT_TRIGGER,
				},
			},
			Type: datadogV2.TRIGGERINVESTIGATIONREQUESTTYPE_TRIGGER_INVESTIGATION_REQUEST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.TriggerInvestigation", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewBitsAIApi(apiClient)
	resp, r, err := api.TriggerInvestigation(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `BitsAIApi.TriggerInvestigation`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `BitsAIApi.TriggerInvestigation`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Trigger a Bits AI investigation returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.BitsAiApi;
import com.datadog.api.client.v2.model.MonitorAlertTriggerAttributes;
import com.datadog.api.client.v2.model.TriggerAttributes;
import com.datadog.api.client.v2.model.TriggerInvestigationRequest;
import com.datadog.api.client.v2.model.TriggerInvestigationRequestData;
import com.datadog.api.client.v2.model.TriggerInvestigationRequestDataAttributes;
import com.datadog.api.client.v2.model.TriggerInvestigationRequestType;
import com.datadog.api.client.v2.model.TriggerInvestigationResponse;
import com.datadog.api.client.v2.model.TriggerType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.triggerInvestigation", true);
    BitsAiApi apiInstance = new BitsAiApi(defaultClient);

    TriggerInvestigationRequest body =
        new TriggerInvestigationRequest()
            .data(
                new TriggerInvestigationRequestData()
                    .attributes(
                        new TriggerInvestigationRequestDataAttributes()
                            .trigger(
                                new TriggerAttributes()
                                    .monitorAlertTrigger(
                                        new MonitorAlertTriggerAttributes()
                                            .eventId("1234567890123456789")
                                            .eventTs(1700000000000L)
                                            .monitorId(12345678L))
                                    .type(TriggerType.MONITOR_ALERT_TRIGGER)))
                    .type(TriggerInvestigationRequestType.TRIGGER_INVESTIGATION_REQUEST));

    try {
      TriggerInvestigationResponse result = apiInstance.triggerInvestigation(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BitsAiApi#triggerInvestigation");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Trigger a Bits AI investigation returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_bits_ai::BitsAIAPI;
use datadog_api_client::datadogV2::model::MonitorAlertTriggerAttributes;
use datadog_api_client::datadogV2::model::TriggerAttributes;
use datadog_api_client::datadogV2::model::TriggerInvestigationRequest;
use datadog_api_client::datadogV2::model::TriggerInvestigationRequestData;
use datadog_api_client::datadogV2::model::TriggerInvestigationRequestDataAttributes;
use datadog_api_client::datadogV2::model::TriggerInvestigationRequestType;
use datadog_api_client::datadogV2::model::TriggerType;

#[tokio::main]
async fn main() {
    let body = TriggerInvestigationRequest::new(TriggerInvestigationRequestData::new(
        TriggerInvestigationRequestDataAttributes::new(TriggerAttributes::new(
            MonitorAlertTriggerAttributes::new(
                "1234567890123456789".to_string(),
                1700000000000,
                12345678,
            ),
            TriggerType::MONITOR_ALERT_TRIGGER,
        )),
        TriggerInvestigationRequestType::TRIGGER_INVESTIGATION_REQUEST,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.TriggerInvestigation", true);
    let api = BitsAIAPI::with_config(configuration);
    let resp = api.trigger_investigation(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Trigger a Bits AI investigation returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.triggerInvestigation"] = true;
const apiInstance = new v2.BitsAIApi(configuration);

const params: v2.BitsAIApiTriggerInvestigationRequest = {
  body: {
    data: {
      attributes: {
        trigger: {
          monitorAlertTrigger: {
            eventId: "1234567890123456789",
            eventTs: 1700000000000,
            monitorId: 12345678,
          },
          type: "monitor_alert_trigger",
        },
      },
      type: "trigger_investigation_request",
    },
  },
};

apiInstance
  .triggerInvestigation(params)
  .then((data: v2.TriggerInvestigationResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
